routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\PostController;
use App\Http\Controllers\CategoryController;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get("/category","App\Http\Controllers\CategoryController@index");
// Route::post("/category/create","App\Http\Controllers\CategoryController@create");
// Route::post("/category","App\Http\Controllers\CategoryController@store");
// Route::get("/category/{categoryId}/edit","App\Http\Controllers\CategoryController@edit");
// Route::put("/category/{categoryId}","App\Http\Controllers\CategoryController@update")->name('category.update');
// Route::delete("/category/{categoryId}","App\Http\Controllers\CategoryController@destroy");
// Route::get('/admin', function () {
//     return view('admin.index');
// });

Route::get('/', function () {
    return view('home.index');
});


Route::resource('posts', PostController::class);
Route::resource('categories', CategoryController::class);

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;
    protected $table = 'categories';
    protected $fillable  = ['name','description'];
}

app/Models/Post.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Post extends Model
{
    use HasFactory;

    protected $fillable = array('category_id','title','author','image','short_desc','description');

    public function category() {
        return $this->belongsTo(Category::class);
    }
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use Illuminate\Http\Request;
use Session;
class CategoryController extends Controller
{
    public function index()
    {
        $categories = Category::all();
        return view('categories.index')->with('categories', $categories);
    }
    public function create()
    {
        return view('categories.create');
    }
    public function store(Request $request)
    {
        $validated = $request->validate([
            'name' => 'required',
        ]);
        Category::create([
            'name' => $request->name,
            'description' => $request->description
        ]);
        Session::flash('cat_create', 'Create successfull!');
        return redirect()->back();
    }


    public function edit($id)
    {
        $categories = Category::find($id);
        return view('categories.edit')->with('categories', $categories);
    }

    public function update(Request $request, $id)
    {
        $validated = $request->validate([
            'name' => 'required',
        ]);
        Category::find($id)->update([
            'name' => $request->name,
            'description' => $request->description
        ]);
        Session::flash('cat_update', 'Updated successfull!');
        return redirect()->back();
    }

    public function destroy($id)
    {
        $category = Category::findOrFail($id);
        $category->delete();
        Session::flash('cat_detele', 'Deleted successfull!');
        return redirect()->back();
    }

}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/PostController.php
<?php

namespace App\Http\Controllers;
use App\Models\Category;
use Illuminate\Http\Request;
use App\Models\Post;

class PostController extends Controller
{

    public function index()
    {
        $posts = Post::all();
        return view('posts.index')->with('posts', $posts);
    }
    public function create()
    {
        $categories = Category::all();
        return view('posts.create')->with('categories', $categories);
    }

    public function store(Request $request)
    {
        $updateData = $request->validate([
            'category_id' => 'required',
            'title' => 'required',
            'image' => 'required',
            'author' => 'required',
            'short_desc' => 'required',
            'description' => 'required',
        ]);

        // Create The Post
        $post = new Post;
        $image = $request->file('image');
        $filename = time() . '.' . $image->getClientOriginalExtension();
       
        $upload = 'post/assets/img/';
        $filename = time().$image->getClientOriginalName();
        $path = move_uploaded_file($image->getPathName(), $upload. $filename);

        if($request->file('image') != ""){
            $image = $request->file('image');
            $upload = 'post/assets/img/';
            $filename = time().$image->getClientOriginalName();
            $path = move_uploaded_file($image->getPathName(), $upload. $filename);
		}

        $post->category_id = $request->category_id;
        $post->title = $request->title;
        $post->image = $filename;
        $post->author = $request->author;
        $post->short_desc = $request->short_desc;
        $post->description = $request->description;
        $post->save();
        return redirect()->back();
   }
   public function destroy($id)
   {
       $posts = Post::findOrFail($id);
       $posts->delete();

       return redirect('/posts')->with('completed', 'Posts has been deleted');
   }

   public function edit($id)
    {
        $post = Post::find($id);
        return view('posts.edit')->with('post', $post);
    }

    public function update(Request $request, $id)
    {
        $updateData = $request->validate([
            'category_id' => 'required|integer',
            'title' => 'required',
            'image' => 'required',
            'author' => 'required',
            'short_desc' => 'required',
            'description' => 'required',
        ]);
        Post::whereId($id)->update($updateData);
        return redirect('/posts')->with('completed', 'Catgory has been updated');
    }
}

resources/views/admin/index.blade.php
{{-- @extends('admin.layout')
@section('content')
<main>
    <div class="container-fluid px-4 title-category">
        <h3 class="mt-4">Static Navigation</h3>
        <ol class="breadcrumb mb-4">
            <li class="breadcrumb-item"><a href="index.html">Dashboard</a></li>
            <li class="breadcrumb-item active">Static Navigation</li>
        </ol>
    </div>
</main>
@endsection --}}

resources/views/categories/create.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid title-category">
        <h3 class="mt-4">Create Category</h3>
        <ol class="breadcrumb mb-4">
            <li class="breadcrumb-item"><a href="{{url('categories')}}">Category</a></li>
            <li class="breadcrumb-item active">Next</li>
        </ol>
        <div class="container">
            <div class="row">
                <div class="col-12">
                    @if(Session::has('cat_create'))
                    <div class="alert alert-success"><em>{!! session('cat_create') !!}</em></div>
                    @endif
                </div>
                <div class="col-12">
                    <form method="post" action="{{route('categories.store')}}">
                        <div class="card">
                            <div class="card-header text-center">
                                <h3>Create Category</h3>
                            </div>
                            <div class="card-body">
                                @csrf
                                <div class="form-group">
                                    <label for="name">Name<span class="text-danger">*</span></label>
                                    <input type="text" class="form-control @error('name') is-invalid @enderror" id="name" name="name" value="{{old('name')}}" placeholder="Enter your name">
                                    @error('name')
                                        <div class="alert alert-danger">{{ $message }}</div>
                                    @enderror
                                </div>
                                <div class="form-group mt-2">
                                    <label for="description">Description</label>
                                    <textarea class="form-control" style="height:150px" name="description" placeholder="Description">{{old('description')}}</textarea>
                                </div>
                            </div>
                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary mt-2">Save</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</main>

@endsection

resources/views/categories/edit.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid title-category">
        <h3 class="mt-4">Update Category</h3>
        <ol class="breadcrumb mb-4">
            <li class="breadcrumb-item"><a href="{{url('categories')}}">Categories</a></li>
            <li class="breadcrumb-item active">Next</li>
        </ol>
        <div class="container">
            <div class="row">
                <div class="col-12">
                    @if(Session::has('cat_update'))
                    <div class="alert alert-success"><em>{!! session('cat_update') !!}</em></div>
                    @endif
                </div>
                <div class="col-12">
                    <form method="post" action="{{url('categories',$categories->id)}}">
                        <div class="card">
                            <div class="card-header text-center">
                                <h3>Update Category</h3>
                            </div>
                            <div class="card-body">
                                @csrf
                                @method('PATCH')
                                <div class="form-group">
                                    <label for="name">Name<span class="text-danger">*</span></label>
                                    <input type="text" class="form-control @error('name') is-invalid @enderror" id="name" name="name"  value="{{ $categories->name }}">
                                    @error('name')
                                        <div class="alert alert-danger">{{ $message }}</div>
                                    @enderror
                                </div>
                                <div class="form-group">
                                    <label>Description</label>
                                    <textarea class="form-control" style="height:150px" name="description" placeholder="description">{{ $categories->description }}</textarea>
                                </div>
                            </div>
                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary mt-2">Save</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</main>

@endsection

resources/views/categories/index.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid px-4 title-category">
        <h3 class="mt-4">List Categories</h3>
        <ol class="breadcrumb mb-4">
            <li class="breadcrumb-item">Category</li>
            <li class="breadcrumb-item active">Next</li>
        </ol>
        <div class="container">
            <div class="row">
                <div class="col-12" style="text-align: right;">
                    <a href="{{route('categories.create')}}" class="btn btn-primary" role="button">Add Category</a>
                </div>
            </div>
        </div>
        @if (count($categories) > 0)
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="col-12">
                        @if(Session::has('cat_update'))
                        <div class="alert alert-success"><em>{!! session('cat_update') !!}</em></div>
                        @endif
                    </div>
                </div>
                <div class="col-12">
                    <table class="table table-bordered mt-2">
                        <thead>
                            <th>ID</th>
                            <th>Name</th>
                            <th>Description</th>
                            <th>Action</th>
                        </thead>
                        <tbody>
                            @foreach ($categories as $category)
                            <tr>
                                <td>
                                    <div>{{$category->id}}</div>
                                </td>
                                <td>
                                    <div>{{$category->name}}</div>
            
                                </td>
                                <td>
                                    <div>{!! $category->description !!}</div>
                                </td>
            
                                <td>
            
                                    <a class="btn btn-primary btn-sm" href="{{route('categories.edit',$category->id) }}">Edit</a>
                                    <!--delete category -->
                                    <form action="{{route('categories.destroy', $category->id)}}" method="post" style="display: inline-block">
                                        @csrf
                                        @method('DELETE')
                                        <button class="btn btn-danger btn-sm" type="submit">Delete</button>
                                    </form>
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        @endif
</main>
@endsection

resources/views/common/errors.blade.php
@if (count($errors) > 0)
<!-- Form Error List -->
<div class="alert alert-danger">
	<strong>Something is Wrong</strong>
	<br><br>
	<ul>
		@foreach ($errors->all() as $error)
		<li>{!! $error !!}</li>
		@endforeach
	</ul>
</div>
@endif

resources/views/home/index.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid">
        <div class="container">
            <div class="row">
                <div class="col-12 text-center">
                    <div class="title">
                        <h1>Welcome To Laravel Developer</h1>
                    </div>
                    <div class="text">
                        <p>
                            Laravel is a web application framework with expressive, elegant syntax. A web
                             framework provides a structure and starting point for creating your applica
                             tion, allowing you to focus on creating something amazing while we sweat the
                              details. Laravel strives to provide an amazing developer experience while p
                              roviding powerful features such as thorough dependency injection, an express
                              ve database abstraction layer, queues and scheduled jobs, unit and integrati
                              on testing, and more. Whether you are new to PHP or web frameworks or have ye
                              ars of experience, Laravel is a framework that can grow with you. We'll help 
                              you take your first steps as a web developer or give you a boost as you take 
                              your expertise to the next level. We can't wait to see what you build.
                        </p>
                    </div>
                </div>
            </div>
        </div>
    </div>
</main>
@endsection

resources/views/posts/create.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <h3 class="mt-4">Create Post</h3>
                    <ol class="breadcrumb mb-4">
                        <li class="breadcrumb-item"><a href="{{url('posts')}}">Posts</a></li>
                        <li class="breadcrumb-item active">Next</li>
                    </ol>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <form method="post" action="{{route('posts.store')}}" enctype="multipart/form-data">
                        @csrf
                        <div class="card">
                            <div class="card-header text-center">
                                <h4 class="text-center">Create Posts</h4>
                            </div>
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="title">Title<span class="text-danger">*</span></label>
                                            <input type="text" class="form-control" id="title" name="title" placeholder="title" value="{{old('title')}}">
                                        </div>
                                    </div>
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="author">Author<span class="text-danger">*</span></label>
                                            <input type="text" class="form-control" id="author" name="author" placeholder="author" value="{{old('author')}}">
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="title">Select Category<span class="text-danger">*</span></label>
                                            <select name="category_id" id="" class="form-control">
                                             @foreach($categories as $cat)
                                             <option value="{{$cat->id}}">{{$cat->name}}</option>
                                             @endforeach
                                            </select>
                                        </div>
                                    </div>
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="image">Photo</label>
                                            <input type="file" class="form-control" id="image" name="image">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-12 mt-2">
                                    <div class="form-group">
                                        <label for="short_desc">Short Description</label>
                                        <textarea class="form-control" name="short_desc" placeholder="short description">{{old('short_desc')}}</textarea>
                                    </div>
                                </div>
                                <div class="col-12 mt-2">
                                    <div class="form-group">
                                        <label>Description</label>
                                        <textarea class="form-control" name="description" placeholder="sescription">{{old('description')}}</textarea>
                                    </div>
                                </div>
                            </div>
                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary">Save</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</main>
{{-- <div class="mt-2">
    @include('common.errors')
    @if(Session::has('category_create'))
    <div class="alert alert-success"><em>{!! session('category_create') !!}</em>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times</span></button>
    </div>
    @endif
</div> --}}
@endsection

resources/views/posts/edit.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <h3 class="mt-4">List Posts</h3>
                    <ol class="breadcrumb mb-4">
                        <li class="breadcrumb-item">Posts</li>
                        <li class="breadcrumb-item active">Next</li>
                    </ol>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <form method="post" action="{{route('posts.update',$post->id)}}" enctype="multipart/form-data">
                        @csrf
                        @method('PATCH')
                        <div class="card">
                            <div class="card-header text-center">
                                <h3>Update Post</h3>
                            </div>
                            <div class="card-body">
                                <div class="row">
                                    <div class="col-6">
                                        <div class="form-group">
                                            <label for="title">Title</label>
                                            <input type="text" class="form-control" id="title" name="title" value="{{ $post->title }}">
                                        </div>
                                    </div>
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="author">Author</label>
                                            <input type="text" class="form-control" id="author" name="author" value="{{ $post->author }}">
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="cat_id">Category</label>
                                            <input type="text" class="form-control" id="cat_id" name="category_id" value="{{ $post->category_id }}">
                                        </div>
                                    </div>
                                    <div class="col-6 mt-2">
                                        <div class="form-group">
                                            <label for="image">Image</label>
                                            <input type="text" class="form-control" id="image" name="image" value="{{ $post->image }}">
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-12 mt-2">
                                        <div class="form-group">
                                            <label for="short_desc">Short_Desc</label>
                                            <textarea class="form-control" style="height:150px" name="short_desc" placeholder="Short_Desc">{{ $post->short_desc }}"</textarea>
                                        </div>
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-12 mt-2">
                                        <div class="form-group">
                                            <label>Description:</label>
                                            <textarea class="form-control" style="height:150px" name="description" placeholder="Description">{{ $post->description }}"</textarea>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="card-footer">
                                <button type="submit" class="btn btn-primary mt-2">Save</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</main>

{{-- <div class="mt-2">
    @include('common.errors')
    @if(Session::has('category_create'))
    <div class="alert alert-success"><em>{!! session('category_create') !!}</em>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times</span></button>
    </div>
    @endif
</div> --}}
@endsection

resources/views/posts/index.blade.php
@extends('layouts.index')
@section('content')
<main>
    <div class="container-fluid">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <h3 class="mt-4">List Posts</h3>
                    <ol class="breadcrumb mb-4">
                        <li class="breadcrumb-item">Posts</li>
                        <li class="breadcrumb-item active">Next</li>
                    </ol>
                </div>
            </div>
        </div>
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <a href="posts/create" class="btn btn-primary" role="button">New Posts</a>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    @if (count($posts) > 0)
                        <div class="card-deck mb-2 mt-2">
                            @foreach ($posts as $post)
                            <div class="card mt-2">
                                <div class="card-body">
                                    <div class="row">
                                        <div class="col-2">
                                            <div class="flex-shrink-0">
                                                <img class="" src="{{asset('post/assets/img/'.$post->image)}}" width="100px" class="rounded-circle" alt="..." />
                                            </div>
                                            <h6 class="card-title">Author : {{$post->author}}</h6>
                                        </div>
                                        <div class="col-10">
                                            <h5 class="card-title">Title : {{$post->title}}</h5>
                                            <p class="card-text"><strong>Short_Desc</strong> : {{$post->short_desc}}</p>
                                            <p class="card-text"><strong>Description</strong> : {{$post->description}}</p>
                                        </div>
                                    </div>
                                </div>
                                <div class="card-footer" style="text-align: right;">
                                    <a class="btn btn-primary btn-sm" href="{{route('posts.edit',$post->id)}}">Edit</a>
                                    <!--delete post -->
                                    <form action="{{route('posts.destroy', $post->id)}}" method="post" style="display: inline-block">
                                        @csrf
                                        @method('DELETE')
                                        <button class="btn btn-danger btn-sm" type="submit">Delete</button>
                                    </form>
                                </div>
                            </div>
                            @endforeach
                        </div>
                    @endif
                </div>
            </div>
        </div>
    </div>
</main>
@endsection